
#include <calibinit\dmcalibinit.h>
#include <calibinit\dmcalibinternal.h>

#define TEST_QUAD_NUM 8
#define CORNERS_NUM   (TEST_QUAD_NUM * 4)

//0 1    
// 2  3 45
//6 7

int g_piTest1[TEST_QUAD_NUM] = {0, 0, 0, -1, -1, -1, 0, 0},
    g_piTest2[TEST_QUAD_NUM] = {0, 0, 0, 1, -1, -1, 0, 0},
    g_piTest3[TEST_QUAD_NUM] = {0, 0, 0, 1, 2, 2, 0, 0},
    g_piTest4[TEST_QUAD_NUM] = {0, 0, 0, -1, 1, 1 , 0, 0},
    g_piCornerTest1[2] = {5, 6},
    g_piCornerTest2[4] = {0, 1, 2, 3},
    g_piCornerTest3[4] = {1, 5, 14, 23};

///   
DQuadInfo   g_pQuads[TEST_QUAD_NUM];
DCornerInfo g_pCorners[CORNERS_NUM];

//============================================================
//
//============================================================

void InitTestData1()
{
  /// Corners
  g_pCorners[0].m_vPoint = cvPoint2D32f(0, 0);
  g_pCorners[1].m_vPoint = cvPoint2D32f(10, 0);
  g_pCorners[2].m_vPoint = cvPoint2D32f(20, 0);
  g_pCorners[3].m_vPoint = cvPoint2D32f(30, 0);

  g_pCorners[4].m_vPoint = cvPoint2D32f(0, 10);
  g_pCorners[5].m_vPoint = cvPoint2D32f(10, 10);
  g_pCorners[6].m_vPoint = cvPoint2D32f(20, 10);
  g_pCorners[7].m_vPoint = cvPoint2D32f(30, 10);
  g_pCorners[8].m_vPoint = cvPoint2D32f(40, 10);
  g_pCorners[9].m_vPoint = cvPoint2D32f(50, 10);
  g_pCorners[10].m_vPoint = cvPoint2D32f(60, 10);
  g_pCorners[11].m_vPoint = cvPoint2D32f(70, 10);
  g_pCorners[12].m_vPoint = cvPoint2D32f(80, 10);

  g_pCorners[13].m_vPoint = cvPoint2D32f(0, 20);
  g_pCorners[14].m_vPoint = cvPoint2D32f(10, 20);
  g_pCorners[15].m_vPoint = cvPoint2D32f(20, 20);
  g_pCorners[16].m_vPoint = cvPoint2D32f(30, 20);
  g_pCorners[17].m_vPoint = cvPoint2D32f(40, 20);
  g_pCorners[18].m_vPoint = cvPoint2D32f(50, 20);
  g_pCorners[19].m_vPoint = cvPoint2D32f(60, 20);
  g_pCorners[20].m_vPoint = cvPoint2D32f(70, 20);
  g_pCorners[21].m_vPoint = cvPoint2D32f(80, 20);

  g_pCorners[22].m_vPoint = cvPoint2D32f(0, 30);
  g_pCorners[23].m_vPoint = cvPoint2D32f(10, 30);
  g_pCorners[24].m_vPoint = cvPoint2D32f(20, 30);
  g_pCorners[25].m_vPoint = cvPoint2D32f(30, 30);

  //0 1    
  // 2  3 45
  //6 7

  /// Quads
  g_pQuads[0].m_iCount = 1;
  g_pQuads[0].m_iGroup = -1;
  g_pQuads[0].m_pNeibors[2] = &g_pQuads[2];
  g_pQuads[0].m_pCorners[0] = &g_pCorners[0];
  g_pQuads[0].m_pCorners[1] = &g_pCorners[1];
  g_pQuads[0].m_pCorners[2] = &g_pCorners[5];
  g_pQuads[0].m_pCorners[3] = &g_pCorners[4];

  g_pQuads[1].m_iCount = 1;
  g_pQuads[1].m_iGroup = -1;
  g_pQuads[1].m_pNeibors[3] = &g_pQuads[2];
  g_pQuads[1].m_pCorners[0] = &g_pCorners[2];
  g_pQuads[1].m_pCorners[1] = &g_pCorners[3];
  g_pQuads[1].m_pCorners[2] = &g_pCorners[7];
  g_pQuads[1].m_pCorners[3] = &g_pCorners[6];

  g_pQuads[2].m_iCount = 4;
  g_pQuads[2].m_iGroup = -1;
  g_pQuads[2].m_pNeibors[0] = &g_pQuads[0];
  g_pQuads[2].m_pNeibors[1] = &g_pQuads[1];
  g_pQuads[2].m_pNeibors[2] = &g_pQuads[7];
  g_pQuads[2].m_pNeibors[3] = &g_pQuads[6];

  g_pQuads[2].m_pCorners[0] = &g_pCorners[5];
  g_pQuads[2].m_pCorners[1] = &g_pCorners[6];
  g_pQuads[2].m_pCorners[2] = &g_pCorners[15];
  g_pQuads[2].m_pCorners[3] = &g_pCorners[14];

  g_pQuads[3].m_iCount = 0;
  g_pQuads[3].m_iGroup = -1;
  g_pQuads[3].m_pCorners[0] = &g_pCorners[8];
  g_pQuads[3].m_pCorners[1] = &g_pCorners[9];
  g_pQuads[3].m_pCorners[2] = &g_pCorners[18];
  g_pQuads[3].m_pCorners[3] = &g_pCorners[17];

  g_pQuads[4].m_iCount = 1;
  g_pQuads[4].m_iGroup = -1;
  g_pQuads[4].m_pNeibors[1] = &g_pQuads[5];
  g_pQuads[4].m_pNeibors[2] = &g_pQuads[5];

  g_pQuads[4].m_pCorners[0] = &g_pCorners[10];
  g_pQuads[4].m_pCorners[1] = &g_pCorners[11];
  g_pQuads[4].m_pCorners[2] = &g_pCorners[20];
  g_pQuads[4].m_pCorners[3] = &g_pCorners[19];

  g_pQuads[5].m_iCount = 1;
  g_pQuads[5].m_iGroup = -1;
  g_pQuads[5].m_pNeibors[0] = &g_pQuads[4];
  g_pQuads[5].m_pNeibors[3] = &g_pQuads[4];

  g_pQuads[5].m_pCorners[0] = &g_pCorners[11];
  g_pQuads[5].m_pCorners[1] = &g_pCorners[12];
  g_pQuads[5].m_pCorners[2] = &g_pCorners[21];
  g_pQuads[5].m_pCorners[3] = &g_pCorners[20];

  g_pQuads[6].m_iCount = 1;
  g_pQuads[6].m_iGroup = -1;
  g_pQuads[6].m_pNeibors[1] = &g_pQuads[2];

  g_pQuads[6].m_pCorners[0] = &g_pCorners[13];
  g_pQuads[6].m_pCorners[1] = &g_pCorners[14];
  g_pQuads[6].m_pCorners[2] = &g_pCorners[23];
  g_pQuads[6].m_pCorners[3] = &g_pCorners[22];

  g_pQuads[7].m_iCount = 1;
  g_pQuads[7].m_iGroup = -1;
  g_pQuads[7].m_pNeibors[0] = &g_pQuads[2];

  g_pQuads[7].m_pCorners[0] = &g_pCorners[15];
  g_pQuads[7].m_pCorners[1] = &g_pCorners[16];
  g_pQuads[7].m_pCorners[2] = &g_pCorners[25];
  g_pQuads[7].m_pCorners[3] = &g_pCorners[24];
}

//============================================================
//
//============================================================

bool TestMarking (DQuadInfo *in_pQuad, int *in_piMarks)
{
  int i = 0;

  for (i = 0; i < TEST_QUAD_NUM; i++)  
    if (in_pQuad[i].m_iGroup != in_piMarks[i])
      return false;

  return true;
}

//============================================================
//
//============================================================

void ClearLines ()
{
  int i = 0;

  for (i = 0; i < CORNERS_NUM; i++)  
    g_pCorners[i].m_iDoneFlag = 0;
}

//============================================================
//
//============================================================

bool TestCornerFind (DCornerInfo **in_ppCorners, int *in_piMarks, int in_iCount)
{
  int i = 0;

  for (i = 0; i < in_iCount; i++)  
    if (in_ppCorners[i] != &g_pCorners[in_piMarks[i]])
      return false;

  return true;
}

//============================================================
//
//============================================================

void AutotestRecursiveFill()
{
  InitTestData1();

  ///   rec_fill
  RecursiveFill(&g_pQuads[0], 0);
  assert(TestMarking(g_pQuads, g_piTest1));
  RecursiveFill(&g_pQuads[3], 1);
  assert(TestMarking(g_pQuads, g_piTest2));
  RecursiveFill(&g_pQuads[5], 2);
  assert(TestMarking(g_pQuads, g_piTest3));

  for (int i = 0; i < 7; i++)
    g_pQuads[i].m_iGroup = -1;

  RecursiveFill(&g_pQuads[7], 0);
  assert(TestMarking(g_pQuads, g_piTest1));
  RecursiveFill(&g_pQuads[3], 1);
  assert(TestMarking(g_pQuads, g_piTest2));
  RecursiveFill(&g_pQuads[4], 2);
  assert(TestMarking(g_pQuads, g_piTest3));
}

//============================================================
//
//============================================================

void AutotestFindGroups()
{
  ///   
  DQuadInfo *ppQuads[TEST_QUAD_NUM];

  InitTestData1();
  int iCount, i;

  ///    
  iCount = FindConnectedQuads(g_pQuads, TEST_QUAD_NUM, ppQuads, 0);
  assert(iCount == 5);
  assert(TestMarking(g_pQuads, g_piTest1));

  for (i = 0; i < iCount; i++)
  {
    assert(ppQuads[i]->m_iGroup == 0);
  }

  ///    
  iCount = FindConnectedQuads(g_pQuads, TEST_QUAD_NUM, ppQuads, 1);
  assert(iCount == 2);
  assert(TestMarking(g_pQuads, g_piTest4));

  for (i = 0; i < iCount; i++)
  {
    assert(ppQuads[i]->m_iGroup == 1);
  }
}

//============================================================
//
//============================================================

void AutotestLineFit()
{
  ///   
  DQuadInfo    *ppQuads[TEST_QUAD_NUM];
  DCornerInfo  *ppCorners[CORNERS_NUM];

  InitTestData1();
  int iCount, i;

  ///    
  iCount = FindConnectedQuads(g_pQuads, TEST_QUAD_NUM, ppQuads, 0);
  assert(iCount == 5);
  assert(TestMarking(g_pQuads, g_piTest1));

  for (i = 0; i < iCount; i++)
  {
    assert(ppQuads[i]->m_iGroup == 0);
  }

  iCount = FindCornersCloseToLine(ppQuads, iCount, 
                                   g_pCorners[4].m_vPoint, g_pCorners[7].m_vPoint, 
                                   ppCorners, 2);

  assert(iCount == 2);

  assert(TestCornerFind(ppCorners, g_piCornerTest1, iCount));

  iCount = FindCornersCloseToLine(ppQuads, iCount, 
                                   g_pCorners[0].m_vPoint, g_pCorners[3].m_vPoint, 
                                   ppCorners, 2);

  assert(iCount == 0);

  //assert(TestCornerFind(ppCorners, g_piCornerTest2, iCount));

  ClearLines();

  iCount = FindCornersCloseToLine(ppQuads, iCount, 
                                   g_pCorners[1].m_vPoint, g_pCorners[23].m_vPoint, 
                                   ppCorners, 2);

  assert(iCount == 0);

  //assert(TestCornerFind(ppCorners, g_piCornerTest3, iCount));


}